#! /usr/bin/cmake -P
#! -*- coding:utf-8; mode:cmake; -*-

ADD_TEST(
    NAME doctest-driver
    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
    COMMAND "${PYTHON_EXECUTABLE}" -m driver.doctests
)

ADD_TEST(
    NAME systest-driver-help
    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
    COMMAND "${PYTHON_EXECUTABLE}" -m driver.deploy --help
)

ADD_TEST(
    NAME systest-driver-version
    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
    COMMAND "${PYTHON_EXECUTABLE}" -m driver.deploy --version
)

ADD_TEST(
    NAME systest-driver-setup
    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
    COMMAND "${CMAKE_COMMAND}" -E make_directory "${PROJECT_BINARY_DIR}/_systest/"
)

ADD_TEST(
    NAME systest-driver-all
    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
    COMMAND "${PYTHON_EXECUTABLE}" -m driver.deploy
            "--configdir=${PROJECT_SOURCE_DIR}/test/config/"
            "--datadir=${PROJECT_BINARY_DIR}/_systest/output/"
            "--execdir=${PROJECT_BINARY_DIR}/"
            --log-level=INFO
            --all
)

ADD_TEST(
    NAME systest-driver-check
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/_systest/output/"
    COMMAND "${PYTHON_EXECUTABLE}" "${PROJECT_SOURCE_DIR}/test/driver-check.py"
)

ADD_TEST(
    NAME systest-driver-cleanup
    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
    COMMAND "${PYTHON_EXECUTABLE}" -m driver.deploy
            "--configdir=${PROJECT_SOURCE_DIR}/test/data/config/"
            "--datadir=${PROJECT_BINARY_DIR}/_systest/output/"
            "--execdir=${PROJECT_BINARY_DIR}"
            --log-level=INFO
            -cc
)

SET_TESTS_PROPERTIES(systest-driver-all PROPERTIES FIXTURES_CLEANUP systest-driver-cleanup)
