#! /usr/bin/python3
#! -*- coding:utf-8; mode:python; -*-

__all__ = [
    'Error',
    'FatalError',
    'ConfigError',
    'RecoverableError',
    'SanityError',
]

class Error(Exception):

    pass

class FatalError(Error):

    pass

class ConfigError(FatalError):

    def __init__(self, message, filename=None, lineno=None):
        if filename is not None:
            if lineno is not None:
                super().__init__("{:s}:{:d} {:s}".format(filename, lineno, message))
            else:
                super().__init__("{:s}: {:s}".format(filename, message))
        else:
            super().__init__(message)

class RecoverableError(Error):

    pass

class SanityError(Error):

    pass
