/* -*- coding:utf-8; mode:javascript; -*- */

const NN = {

    uncoverLayoutTestCase : function(dummy) {
        const info = JSON.parse(dummy.getAttribute('data-info'));
        const number = Number.parseInt(dummy.getAttribute('data-test-case'));
        //const header = document.getElementById('test-case-' + number.toFixed(0));
        //header.style = "";
        dummy.classList.remove('wannabe-layout-comparison');
        dummy.classList.add('layout-comparison');
        const addLayout = function(parent, id, name, informal){
            const div = document.createElement('DIV');
            div.classList.add('pretty');
            div.classList.add('layout');
            div.classList.add(name);
            parent.appendChild(div);
            const a = document.createElement('A');
            a.href = '/layouts/' + id + '/';
            a.title = informal;
            div.appendChild(a);
            const img = document.createElement('IMG');
            img.src = '/layouts/' + id + '/picture.png';
            a.appendChild(img);
        };
        (function(){
            const div = document.createElement('DIV');
            div.classList.add('layout-pair');
            dummy.appendChild(div);
            addLayout(div, info.lhs, 'lhs', info.lhsInformal);
            addLayout(div, info.rhs, 'rhs', info.rhsInformal);
            dummy.appendChild(div);
        })();
        (function(){
            const div = document.createElement('DIV');
            div.classList.add('ruler');
            div.setAttribute('data-value', info.actual);
            div.setAttribute('data-value-expected', info.expected);
            initComparisonRuler(div, number);
            dummy.appendChild(div);
        })();
        dummy.parentNode.style = "";
    },

    enableDynamicScrolling : function() {
        const notice = document.getElementById('scroll-for-more');
        const addStuff = function(){
            notice.style = "display:none";
            for (const dummy of document.getElementsByClassName('wannabe-layout-comparison')) {
                NN.uncoverLayoutTestCase(dummy);
                notice.style = "";
                return;
            }
        };
        const filler = document.getElementById('vertical-fill');
        const listener = function(event) {
            if (NN.isBottomVisible(filler)) {
                addStuff();
            }
        };
        document.addEventListener('scroll', listener);
        while (NN.isBottomVisible(filler)) {
            addStuff();
        }
        notice.style = "";
    },

    disableDynamicScrolling : function() {
        const notice = document.getElementById('scroll-for-more');
        const filler = document.getElementById('vertical-fill');
        notice.parentNode.removeChild(notice);
        filler.parentNode.removeChild(filler);
    },

    removeErrorMessage : function() {
        const node = document.getElementById('something-went-wrong');
        node.parentNode.removeChild(node);
    },

    isBottomVisible : function(element) {
        const rect = element.getBoundingClientRect();
        return rect.bottom <= (window.innerHeight || document.documentElement.clientHeight);
    },

    init : function() {
        if ((location.hash !== null) && (location.hash.startsWith('#test-case-'))) {
            NN.disableDynamicScrolling();
            const header = document.getElementById(location.hash.substring(1));
            const caseno = Number.parseInt(location.hash.substring('#test-case-'.length));
            if ((header !== null) && Number.isFinite(caseno)) {
                console.log("Uncovering test case #" + caseno + " ...");
                for (const dummy of document.getElementsByClassName('wannabe-layout-comparison')) {
                    const number = Number.parseInt(dummy.getAttribute('data-test-case'));
                    if (caseno === number) {
                        NN.uncoverLayoutTestCase(dummy);
                        NN.removeErrorMessage();
                        break;
                    }
                }
            }
        } else {
            for (const dummy of document.getElementsByClassName('wannabe-layout-comparison')) {
                NN.uncoverLayoutTestCase(dummy);
                break;
            }
            NN.enableDynamicScrolling();
            NN.removeErrorMessage();
        }
    }

};  // "namespace" NN
