<?xml version="1.0" encoding="UTF-8"?>

<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" >

  <xsl:output method="html" indent="yes"/>

  <xsl:template match="root">
    <html>
      <head>
        <meta charset="UTF-8" />
        <title>Graphstudy</title>
        <link rel="shortcut icon" type="image/png" href="/graphstudy.png" />
        <link rel="stylesheet" type="text/css" href="/graphstudy.css" />
        <script type="text/javascript" src="/graphstudy.js"></script>
      </head>
      <body onload="init()">
        <h1><xsl:value-of select="id" /></h1>
        <xsl:call-template name="make-summary" />
        <h2>Proper Layouts</h2>
        <p class="alert">TODO: This is not implemented yet.</p>
        <h2>Interpolated Layouts</h2>
        <p class="alert">TODO: This is not implemented yet.</p>
      </body>
    </html>
  </xsl:template>

  <!-- context: /root -->
  <xsl:template name="make-summary">
    <h2>Summary</h2>
    <table class="horizontal">
      <tr>
        <th>Graph-ID</th>
        <td>
          <a>
            <xsl:attribute name="href"><xsl:value-of select="concat('/graphs/', id, '/')" /></xsl:attribute>
            <xsl:value-of select="id" />
          </a>
        </td>
      </tr>
      <tr>
        <th>Generator</th>
        <td><xsl:value-of select="generator" /></td>
      </tr>
      <tr>
        <th>Size-Class</th>
        <td><xsl:value-of select="size" /></td>
      </tr>
      <tr>
        <th>Nodes</th>
        <td class="number-int"><xsl:value-of select="nodes" /></td>
      </tr>
      <tr>
        <th>Edges</th>
        <td class="number-int"><xsl:value-of select="edges" /></td>
      </tr>
    </table>
  </xsl:template>

</xsl:transform>
