<?xml version="1.0" encoding="UTF-8"?>

<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" >

  <xsl:output method="html" indent="yes"/>

  <xsl:template match="root">
    <html>
      <head>
        <meta charset="UTF-8" />
        <title>Graphstudy</title>
        <link rel="shortcut icon" type="image/png" href="/graphstudy.png" />
        <link rel="stylesheet" type="text/css" href="/graphstudy.css" />
        <script type="text/javascript" src="/graphstudy.js"></script>
      </head>
      <body onload="init()">
        <h1>Tool Performance Summary</h1>
        <table class="pretty">
          <tr>
            <th class="clicksort" data-sort-type="s">Tool</th>
            <th class="clicksort" data-sort-type="d">Calls</th>
            <th class="clicksort" data-sort-type="f">Absolute</th>
            <th class="clicksort" data-sort-type="f">Relative</th>
            <th class="clicksort" data-sort-type="f">Minimum</th>
            <th class="clicksort" data-sort-type="f">Maximum</th>
            <th class="clicksort" data-sort-type="f">Median</th>
            <th class="clicksort" data-sort-type="f">Mean</th>
          </tr>
          <tr>
            <th>&#x2014;</th>
            <th>1</th>
            <th>H:MM:SS</th>
            <th>%</th>
            <th>H:MM:SS</th>
            <th>H:MM:SS</th>
            <th>H:MM:SS</th>
            <th>H:MM:SS</th>
          </tr>
          <xsl:for-each select="tool">
            <tr>
              <td><xsl:value-of select="@name" /></td>
              <td class="number-int"     ><xsl:value-of select="cnt" /></td>
              <td class="number-duration"><xsl:value-of select="abs" /></td>
              <td class="number-percent" ><xsl:value-of select="rel" /></td>
              <td class="number-duration"><xsl:value-of select="min" /></td>
              <td class="number-duration"><xsl:value-of select="max" /></td>
              <td class="number-duration"><xsl:value-of select="med" /></td>
              <td class="number-duration"><xsl:value-of select="avg" /></td>
            </tr>
          </xsl:for-each>
        </table>
      </body>
    </html>
  </xsl:template>

</xsl:transform>
