#! /usr/bin/python3
#! -*- coding:utf-8; mode:python; -*-

__all__ = [ 'serve' ]

import http
import logging

from . import *
from ..constants import *
from ..utility import *
from .impl_common import *

def serve(this, graphid, url=None):
    graphrow = get_one_or(this.server.graphstudy_manager.sql_select('Graphs', id=graphid))
    if graphrow is None:
        raise HttpError(http.HTTPStatus.NOT_FOUND, "No graph with ID {!s} exists.".format(graphid))
    root = ET.Element('root')
    append_child(root, 'id').text = str(graphid)
    append_common_all_constants(root, Layouts)
    append_common_graph(root, graphrow, tag=None)
    this.send_tree_xml(ET.ElementTree(root), transform='/xslt/graph.xsl')
