#! /usr/bin/cmake -P
#! -*- coding:utf-8; mode:cmake; -*-

INCLUDE(ExternalProject)

SET(depsdir "${CMAKE_BINARY_DIR}/dependencies")
SET(ogdfdir "${depsdir}/ogdf")

ExternalProject_Add(
    ogdf-dependency
    PREFIX "${depsdir}"
    STAMP_DIR "${depsdir}/ogdf-stamp"
    SOURCE_DIR "${ogdfdir}"
    URL "http://ogdf.net/lib/exe/fetch.php/tech:ogdf-snapshot-2018-03-28.zip"
    DOWNLOAD_NAME "ogdf-snapshot-2018-03-28.zip"
    URL_HASH "SHA256=347c3fa8dcdbb094f9c43008cbc2934bc5a64a532af4d3fe360a5fa54488440f"
    DOWNLOAD_NO_PROGRESS TRUE
    CMAKE_ARGS "-DCMAKE_COLOR_MAKEFILE=${CMAKE_COLOR_MAKEFILE}"
               "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
               "-DCMAKE_CXX_COMPILER=${OGDF_CMAKE_CXX_COMPILER}"
               "-DCMAKE_CXX_FLAGS=${OGDF_CMAKE_CXX_FLAGS}"
               "-DCMAKE_CXX_FLAGS_DEBUG=${OGDF_CMAKE_CXX_FLAGS_DEBUG}"
               "-DCMAKE_CXX_FLAGS_RELEASE=${OGDF_CMAKE_CXX_FLAGS_RELEASE}"
    BUILD_IN_SOURCE TRUE
    INSTALL_COMMAND ""
)

ADD_LIBRARY(ogdf INTERFACE)
ADD_DEPENDENCIES(ogdf ogdf-dependency)
TARGET_LINK_LIBRARIES(ogdf INTERFACE "${ogdfdir}/libOGDF.a" "${ogdfdir}/libCOIN.a")
TARGET_INCLUDE_DIRECTORIES(ogdf SYSTEM INTERFACE "${ogdfdir}/include")
