/* -*- coding:utf-8; mode:c++; -*- */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "edge_length.hxx"

#include <ogdf/basic/GraphAttributes.h>

#include "point.hxx"

namespace msc
{

    std::vector<double> get_all_edge_lengths(const ogdf::GraphAttributes& attrs)
    {
        auto lengths = std::vector<double>{};
        for (const auto e : attrs.constGraph().edges) {
            const auto p1 = point2d{attrs.x(e->source()), attrs.y(e->source())};
            const auto p2 = point2d{attrs.x(e->target()), attrs.y(e->target())};
            lengths.push_back(distance(p1, p2));
        }
        return lengths;
    }

}  // namespace msc
