/* -*- coding:utf-8; mode:c++; -*- */

/**
 * @file edge_length.hxx
 *
 * @brief
 *     Computing edge lengths.
 *
 */

#ifndef MSC_EDGE_LENGTH_HXX
#define MSC_EDGE_LENGTH_HXX

#include <vector>

#include "ogdf_fwd.hxx"

namespace msc
{

    /**
     * @brief
     *     Computes all edge lengths.
     *
     * @param attrs
     *     layout to operate on
     *
     * @returns
     *     edge lengths in unspecified order
     *
     */
    std::vector<double> get_all_edge_lengths(const ogdf::GraphAttributes& attrs);

}  // namespace msc

#endif  // !defined(MSC_EDGE_LENGTH_HXX)
