/* -*- coding:utf-8; mode:c++; -*- */

/**
 * @file logging.hxx
 *
 * @brief
 *     TODO: Explain this header file
 *
 */

#ifndef MSC_LOGGING_HXX
#define MSC_LOGGING_HXX

#define MSC_LOGLEVEL_NONE         0
#define MSC_LOGLEVEL_EMERGENCY    1
#define MSC_LOGLEVEL_ALERT        2
#define MSC_LOGLEVEL_CRITICAL     3
#define MSC_LOGLEVEL_ERROR        4
#define MSC_LOGLEVEL_WARNING      5
#define MSC_LOGLEVEL_NOTICE       6
#define MSC_LOGLEVEL_INFO         7
#define MSC_LOGLEVEL_DEBUG        8
#define MSC_LOGLEVEL_TRACE        9
#define MSC_LOGLEVEL_ALL         10

#ifndef MSC_LOGLEVEL
#  define MSC_LOGLEVEL MSC_LOGLEVEL_NONE
#endif

#define MSC_LOG(LEVEL, ...) ::msc::detail_logging::copy_int(                                                            \
    ((LEVEL) <= (MSC_LOGLEVEL))                                                                                         \
        ? ::msc::detail_logging::log((LEVEL), __FILE__, __LINE__, __VA_ARGS__)                                          \
        : 0                                                                                                             \
    )

#define MSC_LOG_EMERGENCY(...) MSC_LOG(MSC_LOGLEVEL_EMERGENCY, __VA_ARGS__)
#define MSC_LOG_ALERT(...)     MSC_LOG(MSC_LOGLEVEL_ALERT,     __VA_ARGS__)
#define MSC_LOG_CRITICAL(...)  MSC_LOG(MSC_LOGLEVEL_CRITICAL,  __VA_ARGS__)
#define MSC_LOG_ERROR(...)     MSC_LOG(MSC_LOGLEVEL_ERROR,     __VA_ARGS__)
#define MSC_LOG_WARNING(...)   MSC_LOG(MSC_LOGLEVEL_WARNING,   __VA_ARGS__)
#define MSC_LOG_NOTICE(...)    MSC_LOG(MSC_LOGLEVEL_NOTICE,    __VA_ARGS__)
#define MSC_LOG_INFO(...)      MSC_LOG(MSC_LOGLEVEL_INFO,      __VA_ARGS__)
#define MSC_LOG_DEBUG(...)     MSC_LOG(MSC_LOGLEVEL_DEBUG,     __VA_ARGS__)
#define MSC_LOG_TRACE(...)     MSC_LOG(MSC_LOGLEVEL_TRACE,     __VA_ARGS__)

#define MSC_INCLUDED_FROM_LOGGING_HXX
#include "logging.txx"
#undef MSC_INCLUDED_FROM_LOGGING_HXX

#endif  // !defined(MSC_LOGGING_HXX)
