/* -*- coding:utf-8; mode:c++; -*- */

/**
 * @file normalizer.hxx
 *
 * @brief
 *     Normalized layouts.
 *
 */

#ifndef MSC_NORMALIZER_HXX
#define MSC_NORMALIZER_HXX

#include "ogdf_fwd.hxx"

namespace msc
{

    /** @brief Average edge length in normalized layouts. */
    inline constexpr auto default_node_distance = 100.0;

    /**
     * @brief
     *     &ldquo;Normalizes&rdquo; a layout.
     *
     * A normalized layout will be translated to have its center of gravity at the origin and scaled to have an average
     * edge length of 100.
     *
     * @param attrs
     *     layout to be normalized
     *
     */
    void normalize_layout(ogdf::GraphAttributes& attrs);

}  // namespace msc

#endif  // !defined(MSC_NORMALIZER_HXX)
