/* -*- coding:utf-8; mode:c++; -*- */

#ifndef MSC_INCLUDED_FROM_NUMERIC_HXX
#  error "Never `#include <numeric.txx>` directly, `#include <numeric.hxx>` instead"
#endif

#include <cassert>
#include <iterator>

namespace msc
{

    namespace detail_numeric
    {

    }  // namespace detail_numeric

    template <typename FwdIterT>
    double integrate_trapezoidal(const FwdIterT first, const FwdIterT last) noexcept
    {
        assert(first != last);
        auto result = 0.0;
        auto prev = first;
        for (auto it = std::next(first); it != last; ++it) {
            const auto [x1, y1] = *prev;
            const auto [x2, y2] = *it;
            assert(x1 <= x2);
            result += (x2 - x1) * (y1 + y2) / 2.0;
            prev = it;
        }
        return result;
    }

}  // namespace msc
