/* -*- coding:utf-8; mode:c++; -*- */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "random.hxx"

#include <cstdlib>
#include <random>
#include <utility>

namespace msc
{

    namespace random_detail
    {

        std::string get_seed_string()
        {
            if (const auto envval = std::getenv("MSC_RANDOM_SEED")) {
                return envval;
            } else {
                auto rnddev = std::random_device{};
                return random_hex_string(rnddev, 24);
            }
        }

    }  // namespace random_detail

}  // namespace msc
