/* -*- coding:utf-8; mode:c++; -*- */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <chrono>
#include <thread>

#include "cli.hxx"

#define PROGRAM_NAME "sleepy"

namespace /*anonymous*/
{

    struct cli_parameters { };

    struct application
    {
        cli_parameters parameters{};
        void operator()() const;
    };

    void application::operator()() const
    {
        const auto duration = std::chrono::milliseconds{10};
        std::this_thread::sleep_for(duration);
    }

}  // namespace /*anonymous*/

int main(const int argc, const char *const *const argv)
{
    auto app = msc::command_line_interface<application>{PROGRAM_NAME};
    app.help.push_back("Sleeps for 10 milliseconds and then exits.");
    return app(argc, argv);
}
