/* -*- coding:utf-8; mode:c++; -*- */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "testaux/stdio.hxx"

namespace msc::test
{

    capture_stdio::capture_stdio(const std::string& input) :
        _oldbufin{std::cin.rdbuf()},
        _oldbufout{std::cout.rdbuf()},
        _oldbuferr{std::cerr.rdbuf()},
        _tempin{input}
    {
        std::cin.rdbuf(_tempin.rdbuf());
        std::cout.rdbuf(_tempout.rdbuf());
        std::cerr.rdbuf(_temperr.rdbuf());
    }

    capture_stdio::~capture_stdio() noexcept
    {
        std::cin.rdbuf(_oldbufin);
        std::cout.rdbuf(_oldbufout);
        std::cerr.rdbuf(_oldbuferr);
    }

    std::string capture_stdio::get_stdout() const
    {
        return _tempout.str();
    }

    std::string capture_stdio::get_stderr() const
    {
        return _temperr.str();
    }

}  // namespace msc::test
